package github.benjamin.equipreservebackend.exception;

import github.benjamin.equipreservebackend.response.ResponseCode;
import github.benjamin.equipreservebackend.response.ResponseResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.security.authorization.AuthorizationDeniedException;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

@Slf4j
@RestControllerAdvice
public class GlobalExceptionHandler {

    @ExceptionHandler(ApiException.class)
    public ResponseResult<?> handleApiException(ApiException e) {
        return ResponseResult.fail(e.getCode(), e.getMessage());
    }

    @ExceptionHandler(AuthorizationDeniedException.class)
    public ResponseResult<?> handleAuthorizationDeniedException(AuthorizationDeniedException e) {
        return ResponseResult.fail(ResponseCode.UNAUTHORIZED, "该用户无权访问此功能");
    }

    @ExceptionHandler(Exception.class)
    public ResponseResult<?> handleException(Exception e) {
        // TODO 日志
        e.printStackTrace();
        return ResponseResult.fail(ResponseCode.UNKNOWN_ERROR,"服务器内部异常，请联系开发人员");
    }

}
