package github.benjamin.equipreservebackend.response;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class ResponseResult<T> {

    private int code;
    private String message;
    private T data;

    public static <T> ResponseResult<T> success() {
        return ResponseResult.success("success", null);
    }

    public static <T> ResponseResult<T> success(T data) {
        return ResponseResult.success("success", data);
    }

    public static <T> ResponseResult<T> success(String message, T data) {
        return new ResponseResult<>(ResponseCode.SUCCESS, message, data);
    }

    public static <T> ResponseResult<T> fail(Integer code, String message) {
        return new ResponseResult<>(code, message, null);
    }

    public static <T> ResponseResult<T> of(Integer code, String message, T data) {
        return new ResponseResult<>(code, message, data);
    }
}
