package github.benjamin.equipreservebackend.utils;

import org.springframework.web.multipart.MultipartFile;

import java.util.UUID;

public class FileUtil {

    public static String getFileExtension(MultipartFile file) {
        String originalFilename = file.getOriginalFilename();
        return originalFilename.contains(".")
                ? originalFilename.substring(originalFilename.lastIndexOf('.'))
                : "";
    }

    public static String getUniqueFileName(String name, MultipartFile file) {
        String extension = FileUtil.getFileExtension(file);

        // 构建新文件名：设备名称 + UUID + 扩展名
        String safeName = name.replaceAll("[^a-zA-Z0-9\\u4e00-\\u9fa5_-]", "_"); // 防止非法字符
        return safeName + "_" + UUID.randomUUID() + extension;
    }

    private FileUtil(){}

}
