package github.benjamin.equipreservebackend.vo;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import github.benjamin.equipreservebackend.entity.Device;
import github.benjamin.equipreservebackend.entity.User;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class DeviceUserVO {

    @JsonSerialize(using = ToStringSerializer.class)
    private Long deviceId;
    private String name;
    private String usageRequirement;
    private String location;
    private String imagePath;
    /**
     * 直接给出前端要显示的内容：
     * 可预约、有预约
     */
    private String state;

    public DeviceUserVO(Device device) {
        this.deviceId = device.getId();
        this.name = device.getName();
        this.usageRequirement = device.getUsageRequirement();
        this.location = device.getLocation();
        this.imagePath = device.getImagePath();
    }

}
