package github.benjamin.equipreservebackend.vo;

import github.benjamin.equipreservebackend.constant.ReservationStatus;
import github.benjamin.equipreservebackend.entity.Reservation;
import github.benjamin.equipreservebackend.entity.User;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Map;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class UserReservationVO {
    private String reservationId;
    private String deviceName;
    private LocalDate startTime;
    private LocalDate endTime;
    private String statusLabel;
    private String deviceAdminName;
    private String deviceAdminContact;
    private LocalDateTime createdTime;

    public UserReservationVO(Reservation r, Map<Long, String> deviceNameMap) {
        this.reservationId = r.getId().toString();
        this.deviceName = deviceNameMap.get(r.getDeviceId());
        this.startTime = r.getStartTime();
        this.endTime = r.getEndTime();
        this.statusLabel = ReservationStatus.valueOf(r.getStatus()).getLabel();
        this.createdTime = r.getCreatedTime();
    }


    public UserReservationVO(Reservation r, Map<Long, String> deviceNameMap, Map<Long, User> deviceAdminMap) {
        this(r, deviceNameMap);
        ReservationStatus status =  ReservationStatus.valueOf(r.getStatus());
        if (status == ReservationStatus.APPROVED_ASSIST) {
            User deviceAdmin = deviceAdminMap.get(r.getDeviceAdminId());
            this.deviceAdminName = deviceAdmin.getName();
            this.deviceAdminContact = deviceAdmin.getPhone();
        }
    }
}
